﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Annabooks.SparkFunSerLCD;
using System.Threading;


namespace UART_SerLCD2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private SparkFunSerLCD mySerLCD;
#pragma warning disable CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        public MainWindow()
#pragma warning restore CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        {
            InitializeComponent();
            Thread lcdStart = new Thread(new ThreadStart(LCDSetup));
            lcdStart.Start();

        }

        private void LCDSetup()
        {
            mySerLCD = new SparkFunSerLCD("UART1");
            Thread.Sleep(2000);
            if (mySerLCD.LCDstatus())
            {
                Application.Current.Dispatcher.Invoke((Action)(()=> txtStatus.Text = "LCD is Ready"));
            }
            else
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "LCD  is Not ready: " + mySerLCD.connectionError));
            }
        }

        private void btnSend_Click(object sender, RoutedEventArgs e)
        {
            if (mySerLCD.LCDstatus())
            {
                mySerLCD.ClearLCD();
                mySerLCD.LCDBlinkOn();
                mySerLCD.LCDWriteString(txtMessage.Text);
                txtStatus.Text = "Message Sent to LCD";
            }
        }
    }
}
