﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Annabooks.MPL115A1;
using System.Threading;

namespace SPIPressure2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MPL115A1 myPressureSensor;
#pragma warning disable CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        public MainWindow()
#pragma warning restore CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        {
            InitializeComponent();
            Thread setupPressureSensor = new Thread(new ThreadStart(PressureSensorSetup));
            setupPressureSensor.Start();

        }

        private void PressureSensorSetup()
        {
            myPressureSensor = new MPL115A1("SPI2", 8000000, 0, false);
            Thread.Sleep(1000);
            if (myPressureSensor.MPL115A1Status())
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "Preasure Sensor is Ready"));
            }
            else
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "Preasure Sensor is NOT Ready: " + myPressureSensor.connectionError));

            }
        }

        private void btnGetPressure_Click(object sender, RoutedEventArgs e)
        {
            if (myPressureSensor.MPL115A1Status())
            {
                txtPressure.Text = myPressureSensor.ReadPressure_kPa().ToString();
                txtPressureinHg.Text = myPressureSensor.ReadPressure_inHg().ToString();
            }
        }
    }
}
